import Vue from 'vue'
import { HTMLAttributes, Events } from 'vue/types/jsx'
/** Component common definition */
export declare class UIComponent extends Vue {
  /** Install component into Vue */
  static install(vue: typeof Vue): void
}

export type EventHandlers<E> = {
  [K in keyof E]?: E[K] extends (...args: any) => any
    ? E[K]
    : (payload: E[K]) => void
}

export interface Attributes extends HTMLAttributes, EventHandlers<Events> {}

export interface PluginComponentDevOption {
  packageDir?: string // 组件包路径
  output?: string
  externals?: Array<{ [key: string]: string } | Function> // 忽略编译配置
  prefix?: string // 组件名前缀
  lessVar?: string // less 变量参数文件
  lessBase?: string | string[] // 公共文件
  dependentManner?: Record<string, string[]> // 组件相关以来关系
}
